var Benchmark = require("benchmark");
var Navigator = require("../target/server/context/Navigator.js");
var ExpressServerRequest = require("../target/server/ExpressServerRequest.js");
var RequestLocalStorage = require("../target/server/util/RequestLocalStorage.js");

function makePage(nMiddleware) {
    var Middleware = function(){}
    Middleware.prototype.handleRoute = function(next){return next()};

    var middleware = [];
    for (var i = 0; i < nMiddleware; i++) {
        middleware.push(Middleware);
    }

    var Page = function(){};
    Page.middleware = function(){return middleware}

    return Page;
}
var Page = makePage(1000);


var navigator = new Navigator({}, {routes: {}});
var request = new ExpressServerRequest({ query: {} })

function run (deferred) {
    navigator.once('navigateDone', function() {
        deferred.resolve();
    });
    RequestLocalStorage.startRequest(() => {
        navigator.handlePage(Page, request, "pageload");
    });
}

new Benchmark("foo", run, {
    onComplete: function(v){ console.log(v.target.stats.mean) },
    defer: true,
}).run()
